/**

 * mikamiBodyguard.java

 *

 * Copyright (c) 2023 mikami akihiro

 */
package jp.ac.yamagata_u.st.tkr30786;
//追加した箇所　８～１４行、２７，２８行、３８、３９行、４７～６６行、７４行


import java.util.ArrayList;
import java.util.List;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.GuardedAgentContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;


/**
 * 狩人役エージェントクラス
 */
public class mikamiBodyguard extends mikamiVillager {
	/** 護衛したエージェント */
	Agent guardedAgent;
	/*
	 * 追加した点
	 * ↓カミングアウトしたかの変数、護衛成功のカウント
	 */
	private boolean hasCOb;
	int gcount;


	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		guardedAgent = null;
		/*
		 * 追加した点
		 * ↓
		 */
		hasCOb = false;
		gcount = 0;

	}
	/*
	 * 追加した点
	 * ↓自分に投票するエージェントが二人以上いた時狩人COする
	 * 　二回以上護衛に成功したらCOして護衛したエージェントを報告する。
	 */
	public String talk() {
		int countv = 0;
		for (Agent i : voteList) {
			if (i == me) {
				countv += 1;
			}
		}
		if (!hasCOb && countv >= 2) {
			talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.BODYGUARD)));
			hasCOb = true;
		}
		if(!hasCOb && gcount>=2) {
			talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.BODYGUARD)));
			hasCOb = true;	
		}
		if (hasCOb && gcount>=2) {
				talkQueue.offer(new Content(new GuardedAgentContentBuilder(guardedAgent)));
			}
		return super.talk();
	}
		// 自分（村人）を人狼と

	public Agent guard() {
		Agent guardCandidate = null;
		// 前日の護衛が成功しているようなら同じエージェントを護衛
		if (guardedAgent != null && isAlive(guardedAgent) && currentGameInfo.getLastDeadAgentList().isEmpty()) {
			//追加した箇所↓護衛成功した回数
			gcount+=1;
			guardCandidate = guardedAgent;
		}
		// 新しい護衛先の選定
		else {
			gcount=0;
			// 占い師をカミングアウトしていて，かつ人狼候補になっていないエージェントを探す
			List<Agent> candidates = new ArrayList<>();
			for (Agent agent : aliveOthers) {
				if (comingoutMap.get(agent) == Role.SEER && !werewolves.contains(agent)) {
					candidates.add(agent);
				}
			}
			// 見つからなければ霊媒師をカミングアウトしていて，かつ人狼候補になっていないエージェントを探す
			if (candidates.isEmpty()) {
				for (Agent agent : aliveOthers) {
					if (comingoutMap.get(agent) == Role.MEDIUM && !werewolves.contains(agent)) {
						candidates.add(agent);
					}
				}
			}
			// それでも見つからなければ自分と人狼候補以外から護衛
			if (candidates.isEmpty()) {
				for (Agent agent : aliveOthers) {
					if (!werewolves.contains(agent)) {
						candidates.add(agent);
					}
				}
			}
			// それでもいなければ自分以外から護衛
			if (candidates.isEmpty()) {
				candidates.addAll(aliveOthers);
			}
			// 護衛候補からランダムに護衛
			guardCandidate = randomSelect(candidates);
		}
		guardedAgent = guardCandidate;
		return guardCandidate;
	}

}
